/* eslint-disable import/no-extraneous-dependencies */
// cspell:ignore linebreaksfilter
import { Plugin } from 'ckeditor5/src/core';
import LineBreaksFilter from './linebreaksfilter';

/**
 * A plugin that removes or adds HTML markup for linebreaks.
 */
class LineBreaks extends Plugin {

  /**
   * @inheritdoc
   */
  init() {
    const config = this.editor.config.get('linebreaks');
    if (config.method === 'force') {
      this.editor.on('destroy', () => {
        new LineBreaksFilter(this.editor).detach();
      }, {priority: 'lowest'});
    }

    this.editor.on('ready', () => {
      new LineBreaksFilter(this.editor).attach();
    }, { priority: 'lowest' } );
  }

  /**
   * @inheritdoc
   */
  static get pluginName() {
    return 'LineBreaks';
  }

}

export default LineBreaks;
