<?php

declare(strict_types=1);

namespace Drupal\wysiwyg_linebreaks\Plugin\CKEditor4To5Upgrade;

use Drupal\ckeditor5\HTMLRestrictions;
use Drupal\ckeditor5\Plugin\CKEditor4To5UpgradePluginInterface;
use Drupal\Core\Plugin\PluginBase;
use Drupal\filter\FilterFormatInterface;

/**
 * Provides the CKEditor 4 to 5 upgrade for linebreak's CKEditor plugin.
 *
 * @CKEditor4To5Upgrade(
 *   id = "linebreaks",
 *   cke4_plugin_settings = {
 *     "linebreaks",
 *   }
 * )
 */
class LineBreaks extends PluginBase implements CKEditor4To5UpgradePluginInterface {

  /**
   * {@inheritdoc}
   */
  public function mapCKEditor4ToolbarButtonToCKEditor5ToolbarItem(string $cke4_button, HTMLRestrictions $text_format_html_restrictions): ?array {
    throw new \OutOfBoundsException();
  }

  /**
   * {@inheritdoc}
   */
  public function mapCKEditor4SettingsToCKEditor5Configuration(string $cke4_plugin_id, array $cke4_plugin_settings): ?array {
    switch ($cke4_plugin_id) {
      // @see \Drupal\linkit\Plugin\CKEditorPlugin\Linebreaks
      // @see \Drupal\linkit\Plugin\CKEditor5Plugin\LineBreaks
      case 'linebreaks':
        $settings = [];
        if (empty($cke4_plugin_settings)) {
          return NULL;
        }

        return [
          'LineBreaks' => $cke4_plugin_settings,
        ];

      default:
        throw new \OutOfBoundsException();
    }
  }

  /**
   * {@inheritdoc}
   */
  public function computeCKEditor5PluginSubsetConfiguration(string $cke5_plugin_id, FilterFormatInterface $text_format): ?array {
    throw new \OutOfBoundsException();
  }

}
